Index: src/Actions/MoleculeAction/BondFileAction.def
===================================================================
--- src/Actions/MoleculeAction/BondFileAction.def	(revision 08111add4e3854b9642bec0ae60b58fb491ec273)
+++ src/Actions/MoleculeAction/BondFileAction.def	(revision 2affd161725660cecea8012a86f29f70ce24015a)
@@ -7,6 +7,4 @@
 
 // all includes and forward declarations necessary for non-integral types below
-class MoleculeListClass;
-
 #include "Parameters/Validators/DummyValidator.hpp"
 #include "Parameters/Validators/Specific/FilePresentValidator.hpp"
Index: src/Actions/MoleculeAction/ChangeNameAction.def
===================================================================
--- src/Actions/MoleculeAction/ChangeNameAction.def	(revision 08111add4e3854b9642bec0ae60b58fb491ec273)
+++ src/Actions/MoleculeAction/ChangeNameAction.def	(revision 2affd161725660cecea8012a86f29f70ce24015a)
@@ -7,6 +7,4 @@
 
 // all includes and forward declarations necessary for non-integral types below
-class MoleculeListClass;
-
 #include "Parameters/Validators/DummyValidator.hpp"
 
Index: src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.def
===================================================================
--- src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.def	(revision 08111add4e3854b9642bec0ae60b58fb491ec273)
+++ src/Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.def	(revision 2affd161725660cecea8012a86f29f70ce24015a)
@@ -7,6 +7,4 @@
 
 // all includes and forward declarations necessary for non-integral types below
-class MoleculeListClass;
-
 #include "Parameters/Validators/DummyValidator.hpp"
 #include "Parameters/Validators/GenericValidators.hpp"
Index: src/Actions/MoleculeAction/LoadAction.cpp
===================================================================
--- src/Actions/MoleculeAction/LoadAction.cpp	(revision 08111add4e3854b9642bec0ae60b58fb491ec273)
+++ src/Actions/MoleculeAction/LoadAction.cpp	(revision 2affd161725660cecea8012a86f29f70ce24015a)
@@ -38,4 +38,5 @@
 #include "CodePatterns/Verbose.hpp"
 #include "Descriptors/MoleculeIdDescriptor.hpp"
+#include "Descriptors/MoleculeOrderDescriptor.hpp"
 #include "Parser/Exceptions.hpp"
 #include "Parser/FormatParserInterface.hpp"
@@ -43,5 +44,4 @@
 #include "Parser/FormatParser_Parameters.hpp"
 #include "molecule.hpp"
-#include "MoleculeListClass.hpp"
 #include "World.hpp"
 
@@ -102,10 +102,10 @@
 
     // set file name of last molecule
-    MoleculeList::const_reverse_iterator iter = World::getInstance().getMolecules()->ListOfMolecules.rbegin();
-    (*iter)->SetNameFromFilename(FilenamePrefix.c_str());
-    LOG(0, "Chemical formula is " << (*iter)->getFormula());
+    molecule * const mol = World::getInstance().getMolecule(MoleculeByOrder(-1));
+    mol->SetNameFromFilename(FilenamePrefix.c_str());
+    LOG(0, "Chemical formula is " << mol->getFormula());
 
     return ActionState::ptr(
-        new MoleculeLoadState((*iter)->getId(),FilenamePrefix,FilenameSuffix,boost::shared_ptr<FormatParser_Parameters>(ParserParams),params)
+        new MoleculeLoadState(mol->getId(),FilenamePrefix,FilenameSuffix,boost::shared_ptr<FormatParser_Parameters>(ParserParams),params)
     );
   }
@@ -151,11 +151,11 @@
 
   // set file name of last molecule
-  MoleculeList::const_reverse_iterator iter = World::getInstance().getMolecules()->ListOfMolecules.rbegin();
-  (*iter)->SetNameFromFilename(state->FilenamePrefix.c_str());
-  (*iter)->setId(state->molId);
-  LOG(0, "Chemical formula is " << (*iter)->getFormula());
+  molecule * const mol = World::getInstance().getMolecule(MoleculeByOrder(-1));
+  mol->SetNameFromFilename(state->FilenamePrefix.c_str());
+  mol->setId(state->molId);
+  LOG(0, "Chemical formula is " << mol->getFormula());
 
   return ActionState::ptr(
-      new MoleculeLoadState((*iter)->getId(),state->FilenamePrefix,state->FilenameSuffix,boost::shared_ptr<FormatParser_Parameters>(ParserParams),params)
+      new MoleculeLoadState(mol->getId(),state->FilenamePrefix,state->FilenameSuffix,boost::shared_ptr<FormatParser_Parameters>(ParserParams),params)
   );
 }
Index: src/Actions/MoleculeAction/RotateAroundSelfByAngleAction.def
===================================================================
--- src/Actions/MoleculeAction/RotateAroundSelfByAngleAction.def	(revision 08111add4e3854b9642bec0ae60b58fb491ec273)
+++ src/Actions/MoleculeAction/RotateAroundSelfByAngleAction.def	(revision 2affd161725660cecea8012a86f29f70ce24015a)
@@ -7,5 +7,4 @@
 
 // all includes and forward declarations necessary for non-integral types below
-class MoleculeListClass;
 class Vector;
 
Index: src/Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.def
===================================================================
--- src/Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.def	(revision 08111add4e3854b9642bec0ae60b58fb491ec273)
+++ src/Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.def	(revision 2affd161725660cecea8012a86f29f70ce24015a)
@@ -9,6 +9,4 @@
 #include "Actions/Values.hpp"
 #include "LinearAlgebra/Vector.hpp"
-
-class MoleculeListClass;
 
 #include "Parameters/Validators/Specific/VectorNotZeroValidator.hpp"
Index: src/Actions/MoleculeAction/SaveAdjacencyAction.def
===================================================================
--- src/Actions/MoleculeAction/SaveAdjacencyAction.def	(revision 08111add4e3854b9642bec0ae60b58fb491ec273)
+++ src/Actions/MoleculeAction/SaveAdjacencyAction.def	(revision 2affd161725660cecea8012a86f29f70ce24015a)
@@ -7,6 +7,4 @@
 
 // all includes and forward declarations necessary for non-integral types below
-class MoleculeListClass;
-
 #include "Parameters/Validators/Ops_Validator.hpp"
 #include "Parameters/Validators/Specific/FilePresentValidator.hpp"
Index: src/Actions/MoleculeAction/SaveBondsAction.def
===================================================================
--- src/Actions/MoleculeAction/SaveBondsAction.def	(revision 08111add4e3854b9642bec0ae60b58fb491ec273)
+++ src/Actions/MoleculeAction/SaveBondsAction.def	(revision 2affd161725660cecea8012a86f29f70ce24015a)
@@ -7,6 +7,4 @@
 
 // all includes and forward declarations necessary for non-integral types below
-class MoleculeListClass;
-
 #include "Parameters/Validators/Ops_Validator.hpp"
 #include "Parameters/Validators/Specific/FilePresentValidator.hpp"
Index: src/Actions/MoleculeAction/SaveTemperatureAction.def
===================================================================
--- src/Actions/MoleculeAction/SaveTemperatureAction.def	(revision 08111add4e3854b9642bec0ae60b58fb491ec273)
+++ src/Actions/MoleculeAction/SaveTemperatureAction.def	(revision 2affd161725660cecea8012a86f29f70ce24015a)
@@ -7,6 +7,4 @@
 
 // all includes and forward declarations necessary for non-integral types below
-class MoleculeListClass;
-
 #include "Parameters/Validators/Ops_Validator.hpp"
 #include "Parameters/Validators/Specific/FilePresentValidator.hpp"
